package com.yourcompany.admob;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.PluginRegistry.Registrar;

import com.google.android.gms.ads.InterstitialAd;
import com.google.android.gms.ads.MobileAds;
import com.google.android.gms.ads.AdListener;
import com.google.android.gms.ads.AdRequest;
import android.content.Context;
import android.content.Intent;
import android.widget.FrameLayout;

public class AdmobPlugin implements MethodCallHandler{

  public static Context context;
  static String APP_ID = "YOUR_ADMOB_APP_ID";
  String INTERSTITIAL_AD_UNIT_ID = "YOUR AD UNIT ID";
  String DEVICE_ID = "";
  Boolean TESTING = true;

  public static void registerWith(Registrar registrar) {
    context = registrar.activity().getApplicationContext();
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "admob");
    channel.setMethodCallHandler(new AdmobPlugin());
  }

  String arguments;
  @Override
  public void onMethodCall(MethodCall call, Result result) {
    arguments = call.arguments();

    if(call.method.equals("loadInterstitial")) {
      List<String> list = new ArrayList<String>(Arrays.asList(arguments.split(",")));
      APP_ID = list.get(0);
      INTERSTITIAL_AD_UNIT_ID = list.get(1);
      DEVICE_ID = list.get(2);
      TESTING = Boolean.parseBoolean(list.get(3));
      onLoad(context);
      loadInterstitial();
      result.success(true);
    }

    if(call.method.equals("showInterstitial"))
    {
      if (mInterstitialAd.isLoaded()) {
        mInterstitialAd.show();
        result.success(true);
      }else{result.success(false);}
    }
  }

  public static void onLoad(Context context)
  {
    MobileAds.initialize(context, APP_ID);
  }

  public InterstitialAd mInterstitialAd;
  public void loadInterstitial()
  {
    if(TESTING){INTERSTITIAL_AD_UNIT_ID = "ca-app-pub-3940256099942544/1033173712";}
    mInterstitialAd = new InterstitialAd(context);
    mInterstitialAd.setAdUnitId(INTERSTITIAL_AD_UNIT_ID);

    final AdRequest.Builder adRequestBuilder = new AdRequest.Builder();
    if(DEVICE_ID != ""){adRequestBuilder.addTestDevice(DEVICE_ID);}

    mInterstitialAd.loadAd(adRequestBuilder.build());

    mInterstitialAd.setAdListener(new AdListener() {
      @Override
      public void onAdClosed() {
        mInterstitialAd.loadAd(adRequestBuilder.build());
      }
    });
  }

}
