#import "AdmobPlugin.h"
#import <GoogleMobileAds/GoogleMobileAds.h>

NSString *APP_ID = @"";
NSString *INTERSTITIAL_AD_UNIT_ID = @"";
NSString *DEVICE_ID = @"";
NSString *TESTING = @"";

@implementation AdmobPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"admob"
            binaryMessenger:[registrar messenger]];
  AdmobPlugin* instance = [[AdmobPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

NSString *arguments = @"";
- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
      arguments = call.arguments;
    
      if ([@"loadInterstitial" isEqualToString:call.method]) {
        NSArray *list = [arguments componentsSeparatedByString:@","];
        
        APP_ID = list[0];
        INTERSTITIAL_AD_UNIT_ID = list[1];
        DEVICE_ID = list[2];
        TESTING = list[3];
        [self onLoad];
        self.mInterstitialAd = [self createAndLoadInterstitial];
      }
    if ([@"showInterstitial" isEqualToString:call.method]) {
        if (self.mInterstitialAd.isReady) {
            [self.mInterstitialAd presentFromRootViewController: [UIApplication sharedApplication].keyWindow.rootViewController];
        }
    }
    
}

- (void)onLoad{
    [GADMobileAds configureWithApplicationID:APP_ID];
}

- (GADInterstitial*)createAndLoadInterstitial
{
    GADInterstitial *Interstitial = [[GADInterstitial alloc] initWithAdUnitID:INTERSTITIAL_AD_UNIT_ID];
    GADRequest *request = [GADRequest request];
    if(![DEVICE_ID  isEqual: @""]){request.testDevices = [NSArray arrayWithObjects:DEVICE_ID, kGADSimulatorID, nil];}
    Interstitial.delegate = self;
    [Interstitial loadRequest:request];
    return Interstitial;
}

- (void)interstitialDidDismissScreen:(GADInterstitial *)interstitial {
    self.mInterstitialAd = [self createAndLoadInterstitial];
}


@end
